<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- cli-create-project.qdoc -->
  <title>create-project | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td><td >create-project</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<p class="naviNextPrevious headerNavi">
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#synopsis">Synopsis</a></li>
<li class="level1"><a href="#description">Description</a></li>
<li class="level1"><a href="#options">Options</a></li>
<li class="level2"><a href="#op-op-op-op-blacklist-op-lt-op-blacklist-op-gt-op"><code>--blacklist &lt;blacklist&gt;</code></a></li>
<li class="level2"><a href="#op-op-op-op-whitelist-op-lt-op-whitelist-op-gt-op"><code>--whitelist &lt;whitelist&gt;</code></a></li>
<li class="level2"><a href="#op-op-op-op-flat"><code>--flat</code></a></li>
<li class="level2"><a href="#op-op-op-op-help-op-op-op-op-h-op-op-op-op-op-op"><code>--help|-h|-?</code></a></li>
<li class="level1"><a href="#examples">Examples</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">create-project</h1>
<span class="subtitle"></span>
<!-- $$$cli-create-project.html-description -->
<div class="descr"> <a name="details"></a>
<a name="synopsis"></a>
<h2 id="synopsis">Synopsis</h2>
<pre class="cpp">

  qbs create<span class="operator">-</span>project <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>blacklist <span class="operator">&lt;</span>blacklist<span class="operator">&gt;</span><span class="operator">]</span> <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>whitelist <span class="operator">&lt;</span>whitelist<span class="operator">&gt;</span><span class="operator">]</span>
                     <span class="operator">[</span><span class="operator">-</span><span class="operator">-</span>flat<span class="operator">]</span>

</pre>
<a name="description"></a>
<h2 id="description">Description</h2>
<p>Automatically generates Qbs project files from an arbitrary directory structure. You can filter the files to add to the project by blacklisting or whitelisting them. The command creates nested project files, unless you use the <code>--flat</code> option.</p>
<p>This is a useful starting point when migrating from other build tools, such as qmake or CMake.</p>
<p><b>Note: </b>Run this command from the project directory.</p><p>After generating the initial .qbs files, add the missing configuration variables and functions to them.</p>
<a name="options"></a>
<h2 id="options">Options</h2>
<a name="op-op-op-op-blacklist-op-lt-op-blacklist-op-gt-op"></a>
<h3 id="op-op-op-op-blacklist-op-lt-op-blacklist-op-gt-op"><code>--blacklist &lt;blacklist&gt;</code></h3>
<p>Ignores files whose names match the patterns specified by <code>&lt;blacklist&gt;</code>. The list entries can contain wildcards and are separated by commas.</p>
<p>By default, no files are ignored.</p>
<a name="op-op-op-op-whitelist-op-lt-op-whitelist-op-gt-op"></a>
<h3 id="op-op-op-op-whitelist-op-lt-op-whitelist-op-gt-op"><code>--whitelist &lt;whitelist&gt;</code></h3>
<p>Considers only files whose names match the patterns specified by <code>&lt;whitelist&gt;</code>. The list entries can contain wildcards and are separated by commas.</p>
<p>By default, all files are considered.</p>
<a name="op-op-op-op-flat"></a>
<h3 id="op-op-op-op-flat"><code>--flat</code></h3>
<p>Does not create nested project files, even if there are subdirectories and the top-level directory does not contain any files.</p>
<a name="op-op-op-op-help-op-op-op-op-h-op-op-op-op-op-op"></a>
<h3 id="op-op-op-op-help-op-op-op-op-h-op-op-op-op-op-op"><code>--help|-h|-?</code></h3>
<p>Displays help for the command.</p>
<a name="examples"></a>
<h2 id="examples">Examples</h2>
<p>Creates <code>.qbs</code> files in the project directory when run from there:</p>
<pre class="cpp">

  qbs create<span class="operator">-</span>project

</pre>
</div>
<!-- @@@cli-create-project.html -->
<p class="naviNextPrevious footerNavi">
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
